#include <LiquidCrystal_I2C.h>
#include "DHT.h"
#define DHTPIN 2
#define DHTTYPE DHT22
LiquidCrystal_I2C lcd(0x27, 16, 2);  // I2C address 0x3F, 16 column and 2 rows
DHT dht(DHTPIN, DHTTYPE);



int buttonstateA = 0;
int buttonstatePrevA = 0;
int buttonstateB = 0;
int buttonstatePrevB = 0;
int buttonpinA = 6;//water level indicator dedidcated button for refilling
int buttonpinB = 7;// main on off case button switching
int state = 1;

int atomizationPin = 5;

int potPin = A1;
int waterPin = A3;//water level indicator analog input
int potData = 0;
int waterLvl = 0; //water lvl indicator


void setup()
{
  Serial.begin(9600);
  pinMode(buttonpinA, INPUT);
  pinMode(buttonpinB, INPUT);

  pinMode(atomizationPin, OUTPUT);

  dht.begin();     // initialize the sensor
  lcd.init();      // initialize the lcd
  lcd.backlight(); // open the backlight

}

void loop()
{
  float humData  = dht.readHumidity();    // read humidity
  float tempC = dht.readTemperature(); // read temperature

  potData = analogRead(potPin);
  waterLvl = analogRead(waterPin);



  buttonstatePrevA = buttonstateA;
  buttonstateA = digitalRead(buttonpinA);

  buttonstatePrevB = buttonstateB;
  buttonstateB = digitalRead(buttonpinB);

  switch (state) {

    case 1: //Do nothing
      Serial.println("STATE 1");
      Serial.println(potData);

      lcd.setCursor(0, 0);
      lcd.print("rdy 2 get steamy");

      if ((buttonstateB == HIGH && buttonstatePrevB == LOW) && (waterLvl >= 100)) {
        state = 2;
        lcd.clear();
        break;
      }

      if ((buttonstateB == HIGH && buttonstatePrevB == LOW) && (waterLvl < 100)) {
        state = 3;
        lcd.clear();
        break;
      }
      break;

    case 2: //when in case 2, we are having our humidifier master controlled by WLI
      Serial.println("STATE 2");

      if (isnan(humData) || isnan(tempC)) {
        lcd.setCursor(0, 0);
        lcd.print("Failed");
      }
      else {
        lcd.setCursor(0, 0);  // start to print at the first row
        lcd.print("Temp: ");
        lcd.print(tempC);     // print the temperature
        lcd.print((char)223); // print ° character
        lcd.print("C");

        lcd.setCursor(0, 1);  // start to print at the second row
        lcd.print("humData: ");
        lcd.print(humData);      // print the humidity
        lcd.print("%");
        if (waterLvl < 100) {
          state = 3;
          lcd.clear();
          break;
        }
        if (potData >= humData) {
          digitalWrite(atomizationPin, 1);

          Serial.println("wow its working");

        }

      }
      if (potData < humData) {
        digitalWrite(atomizationPin, 0);

      }
      if (buttonstateB == HIGH && buttonstatePrevB == LOW)
      {
        digitalWrite(atomizationPin, 0);
        state = 1;
        lcd.clear();
        break;
      }

      break;

    case 3:
      Serial.println("water level indicator LOW");

      lcd.setCursor(0, 0);
      lcd.print("water level low!");

      if ((buttonstateA == HIGH && buttonstatePrevA == LOW) && (waterLvl > 100))
      {
        state = 2;
        lcd.clear();
        break;
      }
      if (buttonstateB == HIGH && buttonstatePrevB == LOW)
      {
        digitalWrite(atomizationPin, 0);
        state = 1;
        lcd.clear();
        break;
      }
      break;
  }
}
